function delay(amount) {
  if ( (debugOutput) && (amount > 0) )
  {
    var time = new Date();
    var seconds = time.getSeconds();
    var startCount = 80;
    var newSeconds = 70;

    startCount = (seconds + amount ) % 60;
    time = new Date();
    newSeconds = time.getSeconds();
    while (newSeconds != startCount ) {
      time = new Date();
      newSeconds = time.getSeconds();
    }
  }
}

function dbgIfMsg(condition,message) {
  if(debugOutput && condition) {
    java.lang.System.out.println(message);
  }
}

function dbgMsg(message) {
  if (debugOutput)
    java.lang.System.out.println(message);
}

function cAlert (message) {
  if (!this.silent)
    alert(message);
}
function checkSystemEnvironment() {
  var err = 0;

  dbgMsg("The value of navigator.platform is: " + navigator.platform);
  if (navigator.platform != "Win32") {
    err = -20;
    dbgMsg("Error: Wrong operating system!");
    cAlert("Error: Wrong operating system: " + navigator.platform);
    return err;
  }
  return err;
} 
function cConfirm (message) {
  if (!this.silent)
    return true;
  else
    return confirm(message);
}
function newSub(fName, jarFilePath, tgtVI, tgtFolder, tgtFilePath) {
  dbgMsg("Filename in newSub is: " + jarFilePath);
  var err = su.AddSubcomponent(fName,tgtVI,jarFilePath,tgtFolder,tgtFilePath,
  	this.force );
  dbgIfMsg( (err != 0), "Error Adding SubComponent " + fName + "error value: " + err );
  if (err !=0) {
    newSubFailure = true;
  }
  delay(FileDelayTime);
}
function setupFiles(su) {
  var err=0;

  if (su == null) {
    dbgMsg("Error passing su to setupFiles: " + err);
    return -1;
  }
  err = su.StartInstall("plugins/PocketSoft/RTPatch/",vi,
  	netscape.softupdate.SoftwareUpdate.FULL_INSTALL);
  if (err != 0) {
    dbgMsg("Error at startInstall: " + err);
    return err;
  }
  PIFolder = su.GetFolder("Plugins");
  if (PIFolder == null) {
    dbgMsg("ERROR GETTING FOLDER: Plugins" );
    return -1;
  }
  WFolder = su.GetFolder("Windows");
  if (WFolder == null) {
    dbgMsg("ERROR GETTING FOLDER: Windows" );
    return -1;
  }
  newSub(".RTPatch Plug-in DLL", "NPpatch.dll", vi,PIFolder, "" );
  newSub(".RTPatch DLL", "PATCHW32.DLL", vi,WFolder, "" );
  if (newSubFailure) {
    dbgMsg("Error adding at least one subcomponent.");
    abortMe();
  }
  return 0;
}
function abortMe(err) {
  if (!abortCalled) {
    dbgMsg("Install Aborted." + err);
    cAlert("Install Aborted." + err);
    su.AbortInstall();
    abortCalled = true;
  }
}
var FileDelayTime = 0;
var abortCalled = false;
var newSubFailure = false;
var debugOutput = true;

vi = new netscape.softupdate.VersionInfo(6,50,0,1);
dbgIfMsg( (vi == null), "Warning: Unable to create VersionInfo object.");
su = new netscape.softupdate.SoftwareUpdate( this, "RTPatch Plug-in" );
dbgIfMsg( (su == null), "Warning: Unable to create SoftwareUpdate object.");
java.lang.System.out.println("Starting script...");
var err = 0;
if ( (su != null) ) {
  err = checkSystemEnvironment();
  if ( err == 0 ) {
    dbgMsg( "checkSystemEnvironment succeeded." );
    err = setupFiles(su);
    if (err == 0 ) {
      dbgMsg( "setupFiles succeeded." );
      err = su.FinalizeInstall();
      if (err == 0) {
        dbgMsg( "FinalizeInstall succeeded." );
	navigator.plugins.refresh(true);
      }
      else if (err == 999) {
        cAlert("You must reboot to finish this installation.");
      }
      else {
        dbgMsg("Error at FinalizeInstall: " + err);
	abortMe(err);
      }

    }
    else {
      dbgMsg("Error at setupFiles: " + err);
      abortMe(err);
    }
  }
  else {
    dbgMsg("Error at checkSystemEnvironment: " + err);
    abortMe(err);
  }
}
